<template>
    <b-modal :id="id" hide-header ref="modalTestResult">
        <div v-if="phoneNumber">
            <p v-if="phoneNumber.isSuccesful()" class="h4 text-success">
                <b-icon-check-circle-fill></b-icon-check-circle-fill>&nbsp;
                &nbsp;
                Phone number is valid
            </p>
            <p v-if="phoneNumber.hasBeenCorrected()" class="h4 text-warning">
                <b-icon-check-circle-fill></b-icon-check-circle-fill>&nbsp;
                &nbsp;
                Phone number has been corrected
            </p>
            <p v-if="phoneNumber.isFailed()" class="h4 text-danger">
                <b-icon-x-circle-fill></b-icon-x-circle-fill>&nbsp;
                &nbsp;
                Phone number is invalid
            </p>
            <br />
            <small>
                <dl class="row">
                    <dt class="col-sm-5">Provided value:</dt>
                    <dd class="col-sm-7">{{phoneNumber.originalValue}}</dd>

                    <dt class="col-sm-5" v-if="phoneNumber.isValid">Phone number calculated:</dt>
                    <dd class="col-sm-7" v-if="phoneNumber.isValid">{{phoneNumber.phoneNumber}}</dd>

                    <dt class="col-sm-5" v-if="phoneNumber.isCorrected">Corrections made:</dt>
                    <dd
                        class="col-sm-7"
                        v-if="phoneNumber.isCorrected"
                        v-html="phoneNumber.getCorrectionsText()"
                    ></dd>
                </dl>
            </small>

            <p v-if="phoneNumber.isValid === false">
                Value provided doesn't contain a valid mobile phone number.
                <br />
                The test has completed with the following error: <b>{{phoneNumber.error}}</b>
            </p>
        </div>
        <template v-slot:modal-footer>
            <!-- Emulate built in modal header close button action -->
            <b-button size="sm" variant="outline-primary" @click="close()">Close</b-button>
        </template>
    </b-modal>
</template>

<script>
import { BIconCheckCircleFill } from "bootstrap-vue";
import { BIconXCircleFill } from "bootstrap-vue";

export default {
    name: "ModalTestCSVFile",
    components: {
        BIconCheckCircleFill,
        BIconXCircleFill,
    },
    props: {
        id: { type: String, default: "modal-single-test-result" },
    },
    data() {
        return {
            phoneNumber: null,
        };
    },
    methods: {
        setPhoneNumber(phoneNumber) {
            this.phoneNumber = phoneNumber;
        },
        close() {
            this.phoneNumber = null;
            this.hide();
        },
        show() {
            this.$refs["modalTestResult"].show();
        },
        hide() {
            this.$refs["modalTestResult"].hide();
        },
    },
};
</script>